#include <Wire.h>
#include "__CH4_BNO055i2c_revA.h"
unsigned char I2Caddr_BNO055 = 0x29; /* BNO055 address of Pesky module */
unsigned char ODR_Delay = 10; /*ODR 100Hz (NDOF Operating Mode)*/

void setup() {
   Serial.begin(9600);
   Wire.setSDA(17); /* Teensy 3.2 I2C-SDA line */
   Wire.setSCL(16); /* Teensy 3.2 I2C-SDA line */
   Wire.begin();
   delay(500); /* BNO055 typical start-up time is 400ms */  
}

void loop() {
 int rcvDATA;
 unsigned char bufferBNO055[6];
 signed short LinACC_gVECTOR_Z, LinACC_gVECTOR_Y, LinACC_gVECTOR_X;

  BNO055_Init(I2Caddr_BNO055);
  while(1) {
    delay(ODR_Delay);
    do {
     while(!Serial.available());
     rcvDATA=Serial.read();
    } while(rcvDATA!='@');        
    BNO055_ReadData(I2Caddr_BNO055,bufferBNO055,GravityVector); // LinearAcceleration); //
    LinACC_gVECTOR_X = ( ((signed short)(bufferBNO055[1]<<8)) + ((signed short)bufferBNO055[0]) );
    LinACC_gVECTOR_X/=100;
    LinACC_gVECTOR_Y = ( ((signed short)(bufferBNO055[3]<<8)) + ((signed short)bufferBNO055[2]) );
    LinACC_gVECTOR_Y/=100;
    LinACC_gVECTOR_Z =  ( ((signed short)(bufferBNO055[5]<<8)) + ((signed short)bufferBNO055[4]) );
    LinACC_gVECTOR_Z/=100;

    //LinACC_gVECTOR_Y=LinACC_gVECTOR_Z=0; // X only (blue graph)
    //LinACC_gVECTOR_X=LinACC_gVECTOR_Z=0; // Y only (red graph)
    //LinACC_gVECTOR_X=LinACC_gVECTOR_Y=0;  // Z only (green graph)
    Serial.println((String) (short)LinACC_gVECTOR_X + "," + (signed short)LinACC_gVECTOR_Y + "," + (signed short)LinACC_gVECTOR_Z);
  }
}
